/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2012 by Tidalwave s.a.s. (http://tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.integritychecker.impl;

import org.openide.util.lookup.ServiceProvider;
import it.tidalwave.actor.spi.ActorGroupActivator;
import it.tidalwave.integritychecker.impl.fingerprint.FingerprintComputerActor;
import it.tidalwave.actor.impl.io.fileload.FileLoaderActor;
import it.tidalwave.actor.impl.io.filescan.FileObjectDiscoveryActor;
import static it.tidalwave.actor.spi.ActorActivator.*;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@ServiceProvider(service=IntegrityCheckerActivator.class)
public class IntegrityCheckerActivator extends ActorGroupActivator
  {
    public IntegrityCheckerActivator() 
      {
        add(activatorFor(FileObjectDiscoveryActor.class).withPoolSize(8));
        add(activatorFor(FileLoaderActor.class).withPoolSize(1));
        add(activatorFor(FingerprintComputerActor.class).withPoolSize(4));
        add(activatorFor(MessageRouter.class).withPoolSize(1));
      }
  }
