/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2012 by Tidalwave s.a.s. (http://tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.integritychecker.impl;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.ThreadSafe;
import it.tidalwave.actor.annotation.Actor;
import it.tidalwave.messagebus.annotation.ListensTo;
import it.tidalwave.actor.io.fileload.FileContentsAvailableMessage;
import it.tidalwave.actor.io.fileload.FileLoadRequest;
import it.tidalwave.actor.io.filescan.FileDiscoveredMessage;
import it.tidalwave.integritychecker.fingerprint.FingerprintComputeRequest;
import lombok.extern.slf4j.Slf4j;

/***********************************************************************************************************************
 *
 * FIXME: this router should be only enabled on demand for the context.
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Actor(initialPriority=Thread.MAX_PRIORITY) @ThreadSafe @Slf4j
public class MessageRouter 
  {
    public void onFileDiscovered (final @ListensTo @Nonnull FileDiscoveredMessage message) 
      {
        FileLoadRequest.forPath(message.getPath())
                       .send();
      }
    
    public void onFileLoaded (final @ListensTo @Nonnull FileContentsAvailableMessage message) 
      {
        FingerprintComputeRequest.forPath(message.getPath())
                                 .withContent(message.getContent())
                                 .send();
      }
  }
